using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using System.Threading;
using Syncfusion.Windows.Forms.Grid;



namespace WindowsApplication4
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBox1;
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.Button button1;

		private DataTable mTable = null;

		private Thread t;
		private Thread tt;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();


			mTable = new DataTable();
			mTable.PrimaryKey = new DataColumn[] { mTable.Columns.Add( "key", typeof(int) ) };
			mTable.Columns.Add( "value", typeof(string) );


			//   gridDataBoundGrid1.DataSource = mTable;

			this.gridControl1.ColCount = 2;
			this.gridControl1.ColWidths[1] = 50;
			this.gridControl1.ColWidths[2] = 120;

			mTable.RowChanged += new DataRowChangeEventHandler(RowCountChanged);
			t = new Thread( new ThreadStart( add ));
			tt = new Thread( new ThreadStart( update ));

			t.Priority = Thread.CurrentThread.Priority - 1;
			tt.Priority = Thread.CurrentThread.Priority - 1;

			t.Start();
			tt.Start();

		}

	

		private void add()
		{
			Random rand = new Random();

			while( true )
			{

				DataRow r = mTable.NewRow();

				r["key"] = mTable.Rows.Count;
				r["value"] = rand.Next(10000000);//mTable.Rows.Count;//DateTime.Now.Ticks;

				lock( mTable )
					mTable.Rows.Add( r );

				Thread.Sleep( 20 );
			}
		}
		private void update()
		{
			Random rand = new Random();

			while( true )
			{

				if( mTable.Rows.Count > 0 )
				{

					int row = rand.Next( 0, mTable.Rows.Count );

					DataRow r = null;
					lock( mTable )
						r = mTable.Rows.Find( row );

					if( r != null )
						lock(r)
							r["value"] = rand.Next(10000);//-row;//DateTime.Now.Ticks;

				}
				Thread.Sleep( 200 );
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				t.Abort();
				tt.Abort();
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.textBox1 = new System.Windows.Forms.TextBox();
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(104, 424);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "label1";
			// 
			// textBox1
			// 
			this.textBox1.Location = new System.Drawing.Point(176, 424);
			this.textBox1.Name = "textBox1";
			this.textBox1.Size = new System.Drawing.Size(136, 20);
			this.textBox1.TabIndex = 2;
			this.textBox1.Text = "textBox1";
			// 
			// gridControl1
			// 
			this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridControl1.Location = new System.Drawing.Point(24, 24);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(248, 368);
			this.gridControl1.TabIndex = 3;
			this.gridControl1.Text = "gridControl1";
			this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(this.gridControl1_QueryRowCount);
			this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(this.gridControl1_QueryCellInfo);
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(16, 416);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(72, 24);
			this.button1.TabIndex = 4;
			this.button1.Text = "StartScroll";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(328, 469);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1,
																		  this.gridControl1,
																		  this.textBox1,
																		  this.label1});
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		delegate void gridControl1_QueryCellInfoDelegate(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e);
		private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(this.gridControl1.InvokeRequired)
			{
				gridControl1_QueryCellInfoDelegate qci = new gridControl1_QueryCellInfoDelegate(gridControl1_QueryCellInfo);
				BeginInvoke(qci, new object[] { sender, e});
			}
			else
			{
				if(e.RowIndex > 0 && e.ColIndex > 0)
				{
					e.Style.CellValue = this.mTable.Rows[e.RowIndex-1][e.ColIndex-1];
					e.Handled = true;
				}
			}
		}

		delegate void gridControl1_QueryRowCountDelegate(object sender, GridRowColCountEventArgs e);
		private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			if(this.gridControl1.InvokeRequired)
			{
				gridControl1_QueryRowCountDelegate qrc = new gridControl1_QueryRowCountDelegate(gridControl1_QueryRowCount);
				BeginInvoke(qrc, new object[] {sender, e});
			}
			else
			{
				if(this.mTable != null)

				{
					e.Count =  this.mTable.Rows.Count;
					e.Handled = true;
				}
			}
		}

		private bool scrollGrid = false;
		private void button1_Click(object sender, System.EventArgs e)
		{
			scrollGrid = !scrollGrid;
			if(scrollGrid)
				this.button1.Text = "StopScroll";
			else
				this.button1.Text = "StartScroll";
		}

		delegate void RowCountChangedDelegate(object sender, DataRowChangeEventArgs e);
		private void RowCountChanged(object sender, DataRowChangeEventArgs e)
		{
			if(this.gridControl1.InvokeRequired)
			{
				RowCountChangedDelegate rcc = new RowCountChangedDelegate(RowCountChanged);
				BeginInvoke(rcc, new object[] { sender, e});
			}
			else
			{

				if(this.gridControl1.IsDisposed)
					return; //skip out if already disposed...

				if(e.Action != DataRowAction.Change) //means ~ an add or delete
				{
					int i = mTable.Rows.Count;
					this.label1.Text = i.ToString();
					if(i > 0)
						this.textBox1.Text = mTable.Rows[i-1]["value"].ToString();
					this.gridControl1.ResetVolatileData();
					this.gridControl1.UpdateScrollBars();
					if(scrollGrid)
						this.gridControl1.ScrollCellInView(i, 1);
				}
			}
		}

	}
}
